THE FIRST CALL
Create a virtual account
The following example signs a bodyless GET request. For a bodyless request, the body component is zero bytes.STORE_ID="76909781-c483-48f4-8b9e-a887557b8ccc"
KEY_ID="prod-2026-02"
PRIVATE_KEY="./partner-private-key.pem"
TIMESTAMP="$(date +%s)"
IDEMPOTENCY_ID="$(uuidgen | tr '[:upper:]' '[:lower:]')"
METHOD="GET"
PATH="/v2/ramp/${STORE_ID}/banking/deposits"
CANONICAL="v1.${TIMESTAMP}.${IDEMPOTENCY_ID}.${METHOD}.${PATH}."
SIGNATURE="$(
printf '%s' "$CANONICAL" |
openssl dgst -sha256 -sign "$PRIVATE_KEY" |
openssl base64 -A
)"
curl "https://sandbox-api.bullring.finance${PATH}" \
-H "X-Key-Id: ${KEY_ID}" \
-H "X-Timestamp: ${TIMESTAMP}" \
-H "X-Idempotency-Id: ${IDEMPOTENCY_ID}" \
-H "X-Digital-Signature: ${SIGNATURE}"
import { createSign, randomUUID } from "node:crypto";
import fs from "node:fs";
const path = "/v2/ramp/76909781-c483-48f4-8b9e-a887557b8ccc/banking/deposits";
const timestamp = Math.floor(Date.now() / 1000).toString();
const idempotency = randomUUID();
const canonical = `v1.${timestamp}.${idempotency}.GET.${path}.`;
const signer = createSign("RSA-SHA256");
signer.update(canonical);
const signature = signer.sign(fs.readFileSync("./partner-private-key.pem"), "base64");
const response = await fetch(`https://sandbox-api.bullring.finance${path}`, {
headers: {
"X-Key-Id": "prod-2026-02",
"X-Timestamp": timestamp,
"X-Idempotency-Id": idempotency,
"X-Digital-Signature": signature
}
});
console.log(await response.json());
import base64
import time
import uuid
import requests
from cryptography.hazmat.primitives import hashes, serialization
from cryptography.hazmat.primitives.asymmetric import padding
path = "/v2/ramp/76909781-c483-48f4-8b9e-a887557b8ccc/banking/deposits"
timestamp = str(int(time.time()))
idempotency = str(uuid.uuid4())
canonical = f"v1.{timestamp}.{idempotency}.GET.{path}.".encode()
with open("./partner-private-key.pem", "rb") as key_file:
private_key = serialization.load_pem_private_key(key_file.read(), password=None)
signature = base64.b64encode(
private_key.sign(canonical, padding.PKCS1v15(), hashes.SHA256())
).decode()
response = requests.get(
f"https://sandbox-api.bullring.finance{path}",
headers={
"X-Key-Id": "prod-2026-02",
"X-Timestamp": timestamp,
"X-Idempotency-Id": idempotency,
"X-Digital-Signature": signature,
},
)
print(response.json())
// Sign the UTF-8 bytes of:
// v1.<timestamp>.<idempotency-id>.GET.<path>.
// with RSA-SHA256/PKCS#1 v1.5, then Base64 encode the result.
// Send the result in X-Digital-Signature with the other three headers.
curl "https://sandbox-api.bullring.finance/v2/ramp/76909781-c483-48f4-8b9e-a887557b8ccc/banking/deposits" \
-H "X-Key-Id: prod-2026-02" \
-H "X-Timestamp: ${TIMESTAMP}" \
-H "X-Idempotency-Id: ${IDEMPOTENCY_ID}" \
-H "X-Digital-Signature: ${SIGNATURE}"
{
"currency": "NGN",
"bankInfo": {
"bankAccountNumber": "4000005216",
"bankBeneficiaryName": "Partner NGN"
},
"channelId": "ngn-channel-id-bullring-finance"
}